package outils;

import outils.ListeTableauTriable.TriBulle;
import outils.ListeTableauTriable.TriSelection;

public class ListeChaineeTriable<Type extends Comparable<Type>>
extends ListeChainee<Type>
implements ListeTriable<Type> {
	protected class TriBulle implements Strategie {
		public void execute() {
			System.out.println("méthode du tri bulle");
	        if (nbElem < 2) return;
	        boolean echange = true;
	        ElementDeListe courant, suivant;
	        while(echange) {
	            courant = premier;
	            suivant = courant.suivant;
	            echange = false;
	            while (suivant != null) {
	                if (((Type)courant.contenu).compareTo((Type)suivant.contenu) > 0) {
	                    echangeContenusDe(courant, suivant);
	                    echange = true;
	                }
	                courant = suivant;
	                suivant = courant.suivant;
	            }
	        }
		}
	}
	protected class TriSelection implements Strategie {
		public void execute() {
			System.out.println("méthode du tri sélection");
			ElementDeListe elementMax = dernier;
			ElementDeListe elementCourant;
			for(int passe = 0; passe < nbElem - 1; passe++) {
				elementCourant = premier;
	            for(int indiceCourant = 0; indiceCourant < nbElem - passe - 1; indiceCourant++) {
	                if ((elementCourant.contenu).compareTo(elementMax.contenu) > 0) {
	                    echangeContenusDe(elementCourant, elementMax);
	                }
	                elementCourant = elementCourant.suivant;
	            }
	            elementMax = elementMax.precedent;
	        }
		}
	}
	public ListeChaineeTriable() {
		super();
	}
	private int desordre() {
		int desordre = 0, indiceCourant = 1;
		ElementDeListe elementCourant, elementSuivant;
		elementSuivant = (elementCourant = premier).suivant;
		while(elementSuivant != null) {
            if ((elementCourant.contenu).compareTo(elementSuivant.contenu) > 0) {
            	desordre += indiceCourant;
            }
            elementCourant = elementCourant.suivant;
            elementSuivant = elementSuivant.suivant;
			indiceCourant++;
		}
		return desordre;
	}
	private boolean estEnPetitDesordre() {
		return desordre() < (nbElem * (nbElem + 1)) / 4;
	}
	public void trie() {	
		Strategie methodeDeTri = estEnPetitDesordre() ? new TriBulle() : new TriSelection();
		methodeDeTri.execute();
	}
	private void echangeContenusDe(ElementDeListe e1, ElementDeListe e2) {
        Type svg = e1.contenu;
        e1.contenu = e2.contenu;
        e2.contenu = svg;
	}
}
