package domaine;

import static org.junit.jupiter.api.Assertions.*;

import java.util.Iterator;

import org.junit.jupiter.api.Disabled;
import org.junit.jupiter.api.Test;

import domaine.temps.Heure;
import domaine.temps.HeureV1;
import domaine.temps.HeureV2;
import domaine.temps.MauvaisFormatDHeure;
import domaine.temps.MauvaiseValeurDesHeures;
import domaine.temps.MauvaiseValeurDesMinutes;
import outils.Liste;
import outils.ListeChainee;
import outils.Parcours;

class TestListeDAlarmes {
    @Test
    public void test01Constructeur() {
        ListeDAlarmes lst;
        lst = new ListeDAlarmes();
        assertTrue(lst.estVide());
        assertEquals(0, lst.nombreDElements());
    }
    @Test
    public void test02Ajout() throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        ListeDAlarmes lst;
        lst = new ListeDAlarmes();
        lst.ajoute(new HeureV2("12:00"));
        lst.ajoute(new HeureV2("10:30"));
        lst.ajoute(new HeureV2("16:15"));
        lst.ajoute(new HeureV1(10, 30));
        assertEquals(4, lst.nombreDElements());
        Heure h1, h2;
        Iterator<Heure> it = lst.iterator();
        boolean enOrdreCroissant = true;
        h1 = it.next();
        while(it.hasNext()) {
            h2 = it.next();
            if (h1.compareTo(h2) > 0) enOrdreCroissant = false;
            h1 = h2;
        }
        assertFalse(enOrdreCroissant);
    }
    @Test
    public void test03Tri() throws MauvaisFormatDHeure, MauvaiseValeurDesHeures, MauvaiseValeurDesMinutes {
        ListeDAlarmes lst;
        lst = new ListeDAlarmes();
        lst.ajoute(new HeureV2("12:00"));
        lst.ajoute(new HeureV2("10:30"));
        lst.ajoute(new HeureV2("16:15"));
        lst.ajoute(new HeureV1(10, 30));
        assertEquals(4, lst.nombreDElements());
        Heure h1, h2;
        Iterator<Heure> it = lst.iterator();
        h1 = it.next();
        while(it.hasNext()) {
            h2 = it.next();
            assertTrue(h1.compareTo(h2) <= 0);
            h1 = h2;
        }
    }
}
